/*
 * main.c
 *
 *  Created on: 27.04.2010
 *      Author: jan
 *  Added on:   06.05.2010
 *      Author: klaus
 */


#include "uart_b.h"
#include "uart_i.h"
#include "motor.h"
#include "adc.h"
#include "lcd-twi.h"
#include "twi.h"
#include "rtc.h"
#include <util/delay.h>
#include <stdlib.h>
#include <avr/io.h>

#define DEBUG asm volatile ("nop");

void initLED(){
	DDRA|= (1<<PA3);       // Pin PA3 als Ausgang
	PORTA |= (1<<PA3);     // Pin PA3 auf "1"
} // end ---------------


void ledOn(){
	PORTA |= (1<<PA3);     // Pin PA3 auf "1"
} // end ---------------


void ledOff(){
	PORTA &=~(1<<PA3);     // Pin PA3 auf "0"
} // end ---------------


void led_test(){
	initLED();
	while(1){
		ledOn();
		_delay_ms(1000.0);
		ledOff();
		_delay_ms(500.0);
	}
} // end ---------------


 void motor_test(){
	initDCMotorA();
	initDCMotorB();

	for(;;){
		motorAplus(150);
		motorBplus(100);
		_delay_ms(3000.0);

		motorAminus(150);
		motorBminus(100);
		_delay_ms(3000.0);
	}
} // end ---------------


void sw_test(){
	initLED();
	// switch pullup
	DDRD &= ~(1<<PD2);
	PORTD |= (1<<PD2);

	while(1){
		if(PIND & (1<<PD2)){
			ledOn();
		}
		else{
			ledOff();
		}
		_delay_ms(100);
	}
} // end ---------------


void lcd_test(){
	_delay_ms(10);
	TWI_Init_default();
	LCDInit(0x20);
	_delay_ms(1000);
	LCD_disable_blink();
	_delay_ms(1000);
	LCD_disable_cursor();
	_delay_ms(1000);
	LCD_enable_blink();
	_delay_ms(1000);
	LCD_enable_cursor();
	_delay_ms(1000);
	LCD_puts("Hallo MechSys");
	while(1);
} // end ---------------


void adc_test(){
	unsigned short value;
	char tmps[8];
	_delay_ms(10);
	TWI_Init_default();
	LCDInit(0x20);
	LCD_disable_cursor();
	LCD_disable_blink();
	ADC_Init();
	while(1){
		LCD_clear();
		LCD_setpos(0x00);
		//LCD_return();
		value = ADCReadChannel(ADC0);
		itoa(value,tmps,10);
		LCD_puts(tmps);
		_delay_ms(1000);
	}
} // end ---------------


void rtc_test(){
	TWI_Init_default();
	LCDInit(0x20);
	LCD_disable_cursor();
	LCD_disable_blink();
	initRTC();
	time_t t;
	char tmps[20];
	while(1){
		getCurrentTime(&t);
		//printTime
		LCD_clear();
		LCD_return();
		LCD_puts(itoa(t.mins,tmps,10));
		_delay_ms(100);
	}
} // end ---------------


void uart_loop(){
	init_uart_block_default();
	while(1){
		putc_b(getc_b());
	}
} // end ---------------




int main(){

	// led_test();
	// motor_test();
	// sw_test();
	// uart_loop();
	// lcd_test();
	// rtc_test();
	// adc_test();

#if 1
	initLED();
	volatile uint8_t value = 10;
	// uint8_t value = 10;

	while(1){
		PORTA |= (1<<PA3);     // Pin PA3 auf "1"

		DEBUG

		if(PIND & (1<<PD2)){
			value--;
		}
		else{
			value++;
		}
		_delay_ms(100.0);

		PORTA &=~(1<<PA3);     // Pin PA3 auf "0"
		_delay_ms(100.0);
		

		if(value > 15){
			PORTA |= (1<<PA3); // Pin PA3 auf "1"
		}
		_delay_ms(1000.0);
	}

#endif

}
